console.log('Iniciando PJe-Admissibilidade e PJe-Gestão.');

const listaTRTsAdmissibilidade = ['trt13', 'trt7', 'trt20'];
const listaTRTsGestao = ['trt13', 'trt6', 'trt19'];

const menuLateralSelector = "body > pje-root > mat-sidenav-container > mat-sidenav-content > div > pje-menu-lateral > nav";
waitForKeyElements(menuLateralSelector, function (elements) {
    const url = window.location.href;

    // PJe-Admissibilidade
    if (listaTRTsAdmissibilidade.some(trt => window.location.href.includes(trt))) {
        const controlador = new AdmissibilidadeControlador();
        controlador.acrescentarBotaoAdmissibilidade(menuLateralSelector);
        configurarObservadorPaginaTriagem();
    }

    // PJe-Gestão
    if (listaTRTsGestao.some(trt => window.location.href.includes(trt))) {
        main();
    }
});

const menuLateralSelectorAdmissibilidade = "body > pje-app-root > div > pje-app-execucao > div > div > execucao";
if (window.location.href.includes('pjeadmissibilidade')) {
    console.log('Iniciando PJe-Admissibilidade.');
    waitForKeyElements(menuLateralSelectorAdmissibilidade, function () {
        const url = window.location.href;
        console.log('Iniciou pjeadmissibilidade.');
        // PJe-Admissibilidade
        if (listaTRTsAdmissibilidade.some(trt => window.location.href.includes(trt))) {
            const controlador = new AdmissibilidadeControlador();
            controlador.acrescentarBotaoAdmissibilidade(menuLateralSelectorAdmissibilidade);
        }
    });
}

// // Ícone do Admissibilidade na listagem de processos em Triagem (apenas 2o grau)
// const listaProcessosSelectorAdmissibilidade = "body > pje-root > mat-sidenav-container > mat-sidenav-content > div > pje-menu-lateral > nav";
//     console.log('Colocando ícones do Admissibilidade nos processos.');
//     console.log(window.location.href);
//     waitForKeyElements(listaProcessosSelectorAdmissibilidade, function(elements) {
//
//         console.log('Iniciou lista-processos.');
//         if (window.location.href.includes('lista-processos')) {
//             // Itera sobre os elementos retornados
//             for (const element of elements) {
//                 console.log(element);
//                 // Verifica se o elemento é um span
//                 if (element.tagName === "SPAN") {
//                     // Verifica se o valor do atributo textContent é "Triagem"
//                     if (element.textContent.includes("Triagem")) {
//                         // Executa o código interno
//                         console.log("Triagem ativada!");
//                     }
//                 }
//             }
//         }
//     });
// waitForKeyElements(listaProcessosSelectorAdmissibilidade, function () {
//     const url = window.location.href;
//     console.log('Iniciou pjeadmissibilidade na lista de processos.');
//     // PJe-Admissibilidade
//     if (listaTRTsAdmissibilidade.some(trt => window.location.href.includes(trt))) {
//         const controlador = new AdmissibilidadeControlador();
//         controlador.acrescentarBotaoAdmissibilidade(menuLateralSelectorAdmissibilidade);
//     }
// });

// exemplo: 0000540-70.2023.5.13.0029
function inserirIconeAdmissibilidade(obj, observer) {
    // Verifica se a URL atual é 'https://pje.../lista-processos'
    const textoTriagem = 'Triagem';
    const textoAnalise = 'Análise de secretaria';
    if (!obj.inseriu && window.location.href.includes('lista-processos')) {
        const elementosSpan = Array.from(document.querySelectorAll('span'));
        const elementoTriagemOuAnalise = elementosSpan.find(elemento =>
            (elemento.textContent.includes(textoTriagem) || elemento.textContent.includes(textoAnalise)));
        // const elementoAbrirTarefa = elementosSpan.find(elemento => elemento.textContent === 'Abrir a tarefa' &&
        //     elemento.parentElement.textContent.includes(textoTriagem));

        const elementosImgClipboard = document.querySelectorAll('pje-icone-clipboard');
        let indxElementoImgClipboard = 0;

        if (elementoTriagemOuAnalise) {
            const elementosProcesso = elementosSpan.filter(elemento => elemento.className === 'mat-tooltip-trigger' && elemento.textContent.includes('.5.13.'));
            elementosProcesso.forEach(elementoProcesso => {
                console.log('Número do processo:');
                console.log(elementoProcesso.textContent);
                const imgElementIcone = document.createElement('img');
                imgElementIcone.src = 'https://thenounproject.com/api/private/icons/3643768/edit/?backgroundShape=SQUARE&backgroundShapeColor=%23000000&backgroundShapeOpacity=0&exportSize=752&flipX=false&flipY=false&foregroundColor=%23000000&foregroundOpacity=1&imageFormat=png&rotation=0'
                imgElementIcone.style.width = '30px';
                imgElementIcone.style.height = '30px';
                const imgElementLinkAdmissibilidade = document.createElement('a');
                const dominioPje = window.location.hostname;
                const urlExecucao = `https://${dominioPje}/pjeadmissibilidade/execucao/RE95?NUM_PROCESSO=${elementoProcesso.textContent}`;
                imgElementLinkAdmissibilidade.href = urlExecucao;
                imgElementLinkAdmissibilidade.target = '_blank';
                imgElementLinkAdmissibilidade.appendChild(imgElementIcone);
                const elementoImgClipboard = elementosImgClipboard.item(indxElementoImgClipboard++);
                elementoImgClipboard.parentElement.appendChild(imgElementLinkAdmissibilidade);
            });
            obj.inseriu = true;
        }
    } else {
        if (!window.location.href.includes('lista-processos')) {
            obj.inseriu = false;
        }
    }
}

// Necessario para passar parâmetro por referência
let objInseriuIconeEmTriagem = {inseriu: false};

function configurarObservadorPaginaTriagem() {
    const observer = new MutationObserver((mutationsList, observer) => {
        inserirIconeAdmissibilidade(objInseriuIconeEmTriagem, observer);
    });

    // Configura o observador para observar todo o documento e suas mudanças
    observer.observe(document, {childList: true, subtree: true});
}
